/*****************************************************
Chip type           : ATmega8535
Program             : Motion detector
*****************************************************/
#include <mega8535.h>

#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm
#include <lcd.h>        // Alphanumeric LCD Module functions
#include <delay.h>

#define batas_bawah 125
#define batas_atas 127


interrupt [ADC_INT] void adc_isr(void)        // ADC interrupt service routine
{
unsigned char adc_data;

adc_data=ADCH;
lcd_gotoxy(0,0);
if (adc_data>batas_atas || adc_data<batas_bawah) {lcd_putsf("Gr");}
else lcd_putsf("--");
ADCSRA|=0x40;   // Start new conversion
}

void main(void)
{
ADMUX=0x60;     // ADC left adjust (8-bit), analog input ADC0
ADCSRA=0x8E;    // Int ADC Enable, ADC clock 62k5 Hz
lcd_init(8);    // LCD module initialization
delay_ms(500);
#asm("sei")     // Global enable interrupts
ADCSRA|=0x40;   // Start first conversion

while (1)
      {         
      };
}